#include <feos_comparator>

bool FeOS_BinarySearch(size_t* outPos, const void* key, const void* buffer
	, size_t elemCount, size_t elemSize, int (*comparator)(const void*, const void*))
{
	if (!elemCount || !comparator || !elemSize)
	{
		if (*outPos) *outPos = 0;
		return false;
	}

	size_t min = 0, max = elemCount-1;

	while (max >= min)
	{
		size_t mid = (min + max) / 2;
		int rc = comparator((const char*)buffer + mid*elemSize, key);
		if (rc < 0)
			min = mid + 1;
		else if (rc > 0)
		{
			if (mid == 0) break;
			max = mid - 1;
		} else
		{
			if (outPos) *outPos = mid;
			return true;
		}
	}

	if (outPos) *outPos = min;
	return false;
}
