#include <feos_string>

using namespace FeOS;

String ImmString::SubStr(size_t pos, size_t len) const noexcept
{
	if (len == ~0U) len = Length() - pos;
	return String(m_data + pos, len, 0);
}

String& String::operator +=(StringRef rhs) noexcept
{
	m_data.Remove(Length()); // Remove null-terminator
	m_data.AddMany(rhs.Data(), rhs.Size());
	return *this;
}

String& String::operator +=(char c) noexcept
{
	m_data.Back() = c;
	m_data.Add((char)0);
	return *this;
}

String& String::operator =(StringRef rhs) noexcept
{
	m_data.RemoveAll();
	m_data.AddMany(rhs.Data(), rhs.Size());
	return *this;
}

String& String::Insert(size_t pos, StringRef str) noexcept
{
	m_data.InsertMany(pos, str.Data(), str.Length());
	return *this;
}
